package com.lzmispt.data.resource.service.metadata.impl;

package .tmp;

import com.lzmispt.core.service.authorize.IAuthorize;
import com.lzmispt.data.center.entity.dto.resource.apply.GetApplyDirectoryTreeDTO;
import com.lzmispt.data.center.entity.dto.resource.apply.GetApplyEntityInfoVO;
import com.lzmispt.data.center.entity.dto.resource.metadata.GetDirectoryTreeDataDTO;
import com.lzmispt.data.center.entity.vo.resource.apply.ApplyDirectoryTreeItemVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.ApplyDirectoryTreeVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.DirectoryTreeVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataEntityInfoItemVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataEntityVO;
import com.lzmispt.data.resource.client.DataApplyClient;
import com.lzmispt.data.resource.dao.specialdatabase.IResSpecialDatabaseDao;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataDirectoryDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataEntityDTO;
import com.lzmispt.data.resource.entity.po.specialdatabase.ResDirectoryPO;
import com.lzmispt.data.resource.entity.po.specialdatabase.ResSpecialDatabasePO;
import com.lzmispt.data.resource.entity.vo.metadata.MetaEntityRelationsVO;
import com.lzmispt.data.resource.manager.metadata.MetadataManager;
import com.lzmispt.data.resource.service.datasync.impl.handle.DirectoryTreeSearcherHandler;
import com.lzmispt.data.resource.service.metadata.IApplyService;
import com.lzmispt.data.resource.service.metadata.IResAndDataEntityRelation;
import com.lzmispt.data.resource.service.specialdatabase.IResSpecialDatabase;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.framework.entity.entity.ResultEntity;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;

@Service
public class ApplyServiceImpl implements IApplyService {
  @Autowired
  private DataApplyClient dataApplyClient;
  
  @Autowired
  private IResSpecialDatabaseDao iResSpecialDatabaseDao;
  
  @Autowired
  private IResSpecialDatabase iResSpecialDatabase;
  
  @Autowired
  private IAuthorize authorize;
  
  @Autowired
  private IResSpecialDatabaseDao resSpecialDatabaseDao;
  
  public static final String THEMATIC_LIBRARY = "专题库_";
  
  @Autowired
  IResAndDataEntityRelation iResAndDataEntityRelation;
  
  public ResultEntity<Map> getDirectoryTreeTable(GetDirectoryTreeDataDTO getDirectoryTreeDataDTO, String platCode) {
    Map<Object, Object> resultMap = new HashMap<>();
    try {
      GetApplyDirectoryTreeDTO getApplyDirectoryTreeDTO = new GetApplyDirectoryTreeDTO();
      getApplyDirectoryTreeDTO.setDirectoryId(String.valueOf(getDirectoryTreeDataDTO.getDirectoryId()));
      getApplyDirectoryTreeDTO.setDirectoryName(getDirectoryTreeDataDTO.getDirectoryName());
      getApplyDirectoryTreeDTO.setDirectoryType(getDirectoryTreeDataDTO.getDirectoryType());
      if (DCConst.TRUE.equals(getDirectoryTreeDataDTO.getIsOnlyMasterTable())) {
        getApplyDirectoryTreeDTO.setIsOnlyMasterTable(getDirectoryTreeDataDTO.getIsOnlyMasterTable());
      } else {
        getApplyDirectoryTreeDTO.setIsOnlyMasterTable(DCConst.FALSE);
      } 
      ResultEntity<List<ApplyDirectoryTreeItemVO>> directoryTree = this.dataApplyClient.getDirectoryTree(getApplyDirectoryTreeDTO, getDirectoryTreeDataDTO.getTokenId());
      List<DirectoryTreeVO> directoryTreeVOS = handleApplyDirectoryTree((List<ApplyDirectoryTreeItemVO>)directoryTree.getObj(), platCode);
      resultMap.put("directoryTreeList", directoryTreeVOS);
    } catch (Exception e) {
      resultMap.put("directoryTreeList", new ArrayList());
      e.printStackTrace();
    } 
    List<String> selectParentIdList = getSelectParentId(getDirectoryTreeDataDTO.getSelectIdList());
    resultMap.put("selectParentIdList", selectParentIdList);
    return ResultEntity.successMessage(resultMap);
  }
  
  public MetadataEntityVO parseMetadataEntity(GetApplyEntityInfoVO.EntityInfo entityInfo) {
    if (entityInfo == null)
      return null; 
    MetadataEntityVO result = new MetadataEntityVO();
    Long entityId = (entityInfo.getEntityId() == null) ? null : Long.valueOf(entityInfo.getEntityId());
    result.setDirectoryId(entityId);
    result.setEntityId(entityId);
    result.setDataSourceId((entityInfo.getDataSourceId() == null) ? null : Long.valueOf(entityInfo.getDataSourceId()));
    result.setEntityTableName(entityInfo.getEntityTableName());
    result.setEntityName(entityInfo.getEntityName());
    result.setTableIsSync(entityInfo.getTableIsSync().booleanValue());
    return result;
  }
  
  public MetadataEntityInfoItemVO parseEntityFieldInfo(GetApplyEntityInfoVO.FieldListInfo field) {
    if (field == null)
      return null; 
    MetadataEntityInfoItemVO result = new MetadataEntityInfoItemVO();
    result.setDataItemName(field.getDataItemName());
    result.setIsPrimaryKey(field.getIsPrimaryKey());
    result.setInfoItemName(field.getInfoItemName());
    result.setInfoItemId((field.getInfoItemId() == null) ? null : Long.valueOf(field.getInfoItemId()));
    result.setEntityId((field.getEntityId() == null) ? null : Long.valueOf(field.getEntityId()));
    result.setDataItemId((field.getInfoItemId() == null) ? null : Long.valueOf(field.getInfoItemId()));
    result.setInfoItemParentId(null);
    result.setInfoItemType(field.getInfoItemType());
    result.setIsRequired(field.getIsRequired());
    result.setInfoItemOrder(field.getInEntityOrder());
    result.setInfoItemStatus(field.getInfoItemStatus());
    result.setDataRange(field.getDataRange());
    result.setDataRule(field.getDataRule());
    result.setDataRuleDescription(field.getDataRuleDescription());
    return result;
  }
  
  private List<String> getSelectParentId(List<Long> selectDirectoryIdList) {
    return null;
  }
  
  private List<DirectoryTreeVO> handleApplyDirectoryTree(List<ApplyDirectoryTreeItemVO> treeList, String platCode) {
    List<DirectoryTreeVO> directoryTreeVOList = new ArrayList<>();
    if (CollectionUtils.isEmpty(treeList))
      return directoryTreeVOList; 
    DirectoryTreeVO directoryTreeVO = null;
    Integer directoryLevel = Integer.valueOf(1);
    for (ApplyDirectoryTreeItemVO treeItem : treeList) {
      directoryTreeVO = new DirectoryTreeVO();
      directoryTreeVO.setDirectoryName(treeItem.getDirectoryName());
      directoryTreeVO.setDirectoryId((treeItem.getDirectoryId() == null) ? null : Long.valueOf(treeItem.getDirectoryId()));
      directoryTreeVO.setDirectoryType(treeItem.getDirectoryType());
      directoryTreeVO.setDirectoryLevel(directoryLevel);
      directoryTreeVO.setDirectoryOrder(Integer.valueOf(0));
      directoryTreeVO.setFileTableId(StringUtils.isEmpty(treeItem.getFileTableId()) ? null : Long.valueOf(treeItem.getFileTableId()));
      directoryTreeVO.setPlatCode(platCode);
      if (!CollectionUtils.isEmpty(treeItem.getChildren())) {
        Integer integer1 = directoryLevel, integer2 = directoryLevel = Integer.valueOf(directoryLevel.intValue() + 1);
        recursionHandleApplyDirectoryTree(directoryTreeVO, treeItem.getChildren(), integer1, platCode);
      } 
      directoryTreeVOList.add(directoryTreeVO);
    } 
    return directoryTreeVOList;
  }
  
  private void recursionHandleApplyDirectoryTree(DirectoryTreeVO parentDirectoryTreeVO, List<ApplyDirectoryTreeItemVO> children, Integer directoryLevel, String platCode) {
    parentDirectoryTreeVO.setChildren(new ArrayList());
    DirectoryTreeVO directoryTreeVO = null;
    for (ApplyDirectoryTreeItemVO treeItem : children) {
      directoryTreeVO = new DirectoryTreeVO();
      directoryTreeVO.setDirectoryName(treeItem.getDirectoryName());
      directoryTreeVO.setDirectoryId((treeItem.getDirectoryId() == null) ? null : Long.valueOf(treeItem.getDirectoryId()));
      directoryTreeVO.setDirectoryType(treeItem.getDirectoryType());
      directoryTreeVO.setDirectoryLevel(directoryLevel);
      directoryTreeVO.setDirectoryOrder(Integer.valueOf(0));
      directoryTreeVO.setParentDirectoryId(parentDirectoryTreeVO.getDirectoryId());
      directoryTreeVO.setFileTableId(StringUtils.isEmpty(treeItem.getFileTableId()) ? null : Long.valueOf(treeItem.getFileTableId()));
      directoryTreeVO.setPlatCode(platCode);
      if (!CollectionUtils.isEmpty(treeItem.getChildren())) {
        Integer integer1 = directoryLevel, integer2 = directoryLevel = Integer.valueOf(directoryLevel.intValue() + 1);
        recursionHandleApplyDirectoryTree(directoryTreeVO, treeItem.getChildren(), integer1, platCode);
      } 
      parentDirectoryTreeVO.getChildren().add(directoryTreeVO);
    } 
  }
  
  public ResultEntity<Map> getDirectoryTreeTableForRes(GetDirectoryTreeDataDTO getDirectoryTreeDataDTO, String platCode) {
    Map<Object, Object> data = new HashMap<>();
    if (ObjectUtils.isEmpty(getDirectoryTreeDataDTO.getDataResourceCategory()))
      getDirectoryTreeDataDTO.setDataResourceCategory(getDirectoryTreeDataDTO.getDataCategory()); 
    ResultEntity<Map> result = getDirectoryTreeDataForApply(platCode, getDirectoryTreeDataDTO, null);
    if (result.getCode().intValue() != 0)
      return result; 
    data.put("directoryTreeList", result.getObj());
    List<String> selectParentIdList = getSelectParentId(getDirectoryTreeDataDTO.getSelectIdList());
    data.put("selectParentIdList", selectParentIdList);
    return ResultEntity.successMessage(data);
  }
  
  private ResultEntity getDirectoryTreeDataForApply(String platCode, GetDirectoryTreeDataDTO getDirectoryTreeDataDTO, Long directoryId) {
    return getListResultEntity(platCode, getDirectoryTreeDataDTO, directoryId);
  }
  
  private ResultEntity<List<ApplyDirectoryTreeVO>> getListResultEntity(String platCode, GetDirectoryTreeDataDTO getDirectoryTreeDataDTO, Long directoryId) {
    ResSpecialDatabasePO specialdatabasePO = new ResSpecialDatabasePO();
    List<ApplyDirectoryTreeVO> directoryTreeList = new ArrayList<>();
    List<ResSpecialDatabasePO> resSpecialDatabaseList = this.resSpecialDatabaseDao.selectResSpecialDatabaseAll(specialdatabasePO);
    List<Long> mainTableIds = new ArrayList<>();
    if (DCConst.TRUE.equals(getDirectoryTreeDataDTO.getIsOnlyMasterTable()))
      mainTableIds = getMasterTableDirectoryIds(getDirectoryTreeDataDTO.getDataResourceCategory(), platCode, getDirectoryTreeDataDTO.getTokenId()); 
    for (ResSpecialDatabasePO resSpecialDatabasePO : resSpecialDatabaseList) {
      ApplyDirectoryTreeVO directoryTree = new ApplyDirectoryTreeVO();
      if (Objects.equals("Apply", getDirectoryTreeDataDTO.getPlatCode())) {
        directoryTree.setDirectoryName(resSpecialDatabasePO.getSpecialDatabaseName());
      } else {
        directoryTree.setDirectoryName("专题库__" + resSpecialDatabasePO.getSpecialDatabaseName());
      } 
      directoryTree.setParentDirectoryId(null);
      directoryTree.setDirectoryId(resSpecialDatabasePO.getSpecialDatabaseId());
      directoryTree.setSpecialDatabaseId(resSpecialDatabasePO.getSpecialDatabaseId());
      directoryTreeList.add(directoryTree);
    } 
    for (ApplyDirectoryTreeVO directoryTreeVO : directoryTreeList) {
      List<ApplyDirectoryTreeVO> parentDirectoryTreeList;
      List<ResDirectoryPO> resDirectoryPOList = new ArrayList<>();
      Map<Long, ResAndDataEntityDTO> resAndDataEntityCache = new HashMap<>();
      Map<Long, List<MetaEntityRelationsVO>> metaRelationsCache = new HashMap<>();
      if (StringUtils.isEmpty(getDirectoryTreeDataDTO.getDirectoryName())) {
        resDirectoryPOList = this.iResSpecialDatabaseDao.selectAllDirectoryByDirectoryId(directoryId, getDirectoryTreeDataDTO.getDirectoryType(), null, null, directoryTreeVO.getDirectoryId());
      } else {
        String directoryName = DirectoryTreeSearcherHandler.handleLikeSql(getDirectoryTreeDataDTO.getDirectoryName());
        resDirectoryPOList = this.iResSpecialDatabaseDao.selectAllDirectoryByDirectoryId(directoryId, getDirectoryTreeDataDTO.getDirectoryType(), directoryName, null, directoryTreeVO.getDirectoryId());
      } 
      List<ApplyDirectoryTreeVO> directoryChildTreeList = new ArrayList<>();
      if (CollectionUtils.isEmpty(resDirectoryPOList))
        resDirectoryPOList = new ArrayList<>(); 
      for (ResDirectoryPO resDirectoryPO : resDirectoryPOList) {
        if (DCConst.MetadataDirectoryType.ITEM_INFO.equals(resDirectoryPO.getDirectoryType()) && !CollectionUtils.isEmpty(mainTableIds) && !mainTableIds.contains(resDirectoryPO.getDirectoryId()))
          continue; 
        ApplyDirectoryTreeVO directoryTree = new ApplyDirectoryTreeVO();
        directoryTree.setDirectoryName(resDirectoryPO.getDirectoryName());
        directoryTree.setParentDirectoryId(resDirectoryPO.getParentDirectoryId());
        directoryTree.setDirectoryId(resDirectoryPO.getDirectoryId());
        directoryTree.setDirectoryLevel(resDirectoryPO.getDirectoryLevel());
        directoryTree.setDirectoryType(resDirectoryPO.getDirectoryType());
        directoryTree.setDirectoryOrder(resDirectoryPO.getDirectoryOrder());
        directoryTree.setSpecialDatabaseId(resDirectoryPO.getSpecialDatabaseId());
        directoryChildTreeList.add(directoryTree);
      } 
      if (getDirectoryTreeDataDTO.getDirectoryId() == null) {
        parentDirectoryTreeList = (List<ApplyDirectoryTreeVO>)directoryChildTreeList.stream().filter(s -> (s.getParentDirectoryId() == null)).collect(Collectors.toList());
      } else {
        parentDirectoryTreeList = (List<ApplyDirectoryTreeVO>)directoryChildTreeList.stream().filter(s -> getDirectoryTreeDataDTO.getDirectoryId().equals(s.getParentDirectoryId())).collect(Collectors.toList());
      } 
      getTreeResult(parentDirectoryTreeList, directoryChildTreeList, platCode, getDirectoryTreeDataDTO.getTokenId(), getDirectoryTreeDataDTO.getDataResourceCategory(), metaRelationsCache, resAndDataEntityCache);
      directoryTreeVO.setChildren(parentDirectoryTreeList);
    } 
    if (!StringUtils.isEmpty(getDirectoryTreeDataDTO.getDirectoryName()))
      return ResultEntity.successMessage(processApplyQuery(directoryTreeList)); 
    return ResultEntity.successMessage(directoryTreeList);
  }
  
  private List<Long> getMasterTableDirectoryIds(Integer dataResourceCategory, String platCode, String tokenId) {
    List<ResAndDataDirectoryDTO> resAndDataDirectories = MetadataManager.selectDirectoryByType(DCConst.MetadataDirectoryType.ITEM_INFO, platCode, dataResourceCategory);
    List<Long> dirIds = (List<Long>)resAndDataDirectories.stream().map(ResAndDataDirectoryDTO::getDirectoryId).collect(Collectors.toList());
    List<Long> childTableEntityIds = this.iResAndDataEntityRelation.getChildTableEntityIds(dataResourceCategory, platCode);
    Map<Long, Long> dirIdAndEntityIdMap = MetadataManager.getEntityIdsByDirectoryIds(dirIds, dataResourceCategory, platCode, tokenId);
    dirIdAndEntityIdMap.values().removeAll(childTableEntityIds);
    List<Long> masterTableDirIds = new ArrayList<>(dirIdAndEntityIdMap.keySet());
    return masterTableDirIds;
  }
  
  private List<ApplyDirectoryTreeVO> processApplyQuery(List<ApplyDirectoryTreeVO> directoryTreeList) {
    List<ApplyDirectoryTreeVO> resultDirectoryTreeList = new ArrayList<>();
    if (!CollectionUtils.isEmpty(directoryTreeList))
      for (ApplyDirectoryTreeVO applyDirectoryTreeVO : directoryTreeList) {
        List<ApplyDirectoryTreeVO> children = applyDirectoryTreeVO.getChildren();
        if (!CollectionUtils.isEmpty(children))
          resultDirectoryTreeList.add(applyDirectoryTreeVO); 
      }  
    return resultDirectoryTreeList;
  }
  
  public void getTreeResult(List<ApplyDirectoryTreeVO> directoryList, List<ApplyDirectoryTreeVO> directoryDataList, String platCode, String tokenId, Integer dataResourceCategory, Map<Long, List<MetaEntityRelationsVO>> metaRelationsCache, Map<Long, ResAndDataEntityDTO> resAndDataEntityCache) {
    for (ApplyDirectoryTreeVO directoryTreeVO : directoryList) {
      if (directoryTreeVO.getParentDirectoryId() != null && DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
        ResAndDataDirectoryDTO parentResAndDataDirectoryDTO = MetadataManager.selectDirectoryByDirectoryId(directoryTreeVO.getParentDirectoryId(), platCode, dataResourceCategory);
        if (DCConst.MetadataDirectoryType.ITEM_INFO.equals(parentResAndDataDirectoryDTO.getDirectoryType())) {
          directoryTreeVO.setIsRelationshipComplete(DCConst.FALSE);
        } else {
          directoryTreeVO.setIsRelationshipComplete(DCConst.TRUE);
        } 
        directoryTreeVO.setParentDirectoryName(parentResAndDataDirectoryDTO.getDirectoryName());
      } else {
        directoryTreeVO.setIsRelationshipComplete(DCConst.TRUE);
      } 
      findChildren(directoryTreeVO, directoryDataList, platCode, tokenId, dataResourceCategory, resAndDataEntityCache, metaRelationsCache);
    } 
  }
  
  public ApplyDirectoryTreeVO findChildren(ApplyDirectoryTreeVO directoryTreeVO, List<ApplyDirectoryTreeVO> metadataDirectoryList, String platCode, String tokenId, Integer dataResourceCategory, Map<Long, ResAndDataEntityDTO> resAndDataEntityCache, Map<Long, List<MetaEntityRelationsVO>> metaRelationsCache) {
    for (ApplyDirectoryTreeVO directoryTree : metadataDirectoryList) {
      if (directoryTreeVO.getDirectoryId().equals(directoryTree.getParentDirectoryId())) {
        if (directoryTreeVO.getChildren() == null) {
          directoryTree.setPlatCode(platCode);
          directoryTreeVO.setChildren(new ArrayList());
        } 
        if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory) && DCConst.MetadataDirectoryType.ITEM_INFO.equals(directoryTreeVO.getDirectoryType())) {
          directoryTree.setIsRelationshipComplete(DCConst.FALSE);
        } else {
          directoryTree.setIsRelationshipComplete(DCConst.TRUE);
        } 
        directoryTree.setParentDirectoryName(directoryTreeVO.getDirectoryName());
        directoryTree.setPlatCode(platCode);
        directoryTreeVO.add(findChildren(directoryTree, metadataDirectoryList, platCode, tokenId, dataResourceCategory, resAndDataEntityCache, metaRelationsCache));
      } 
      directoryTree.setPlatCode(platCode);
    } 
    return directoryTreeVO;
  }
}
